searchNodes=[{"doc":"Boruta is the core of an OAuth provider giving business logic of authentication and authorization.It is intended to follow RFCs:RFC 6749 - The OAuth 2.0 Authorization FrameworkRFC 7662 - OAuth 2.0 Token IntrospectionRFC 7009 - OAuth 2.0 Token RevocationRFC 7636 - Proof Key for Code Exchange by OAuth Public ClientsAs it, it helps implement a provider for authorization code, implicit, client credentials and resource owner password credentials grants. Then it follows Introspection to check tokens.InstallationSchemas migrationIf you plan to use Boruta builtin clients and tokens contexts, you'll need a migration for its Ecto schemas. This can be done by running:mix boruta.gen.migrationImplement ResourceOwners contextIn order to have user flows working, You need to implement Boruta.Oauth.ResourceOwners.Here is an example implementation:defmodule MyApp.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by(username: username) do with %User{id: id, email: email} &lt;- Repo.get_by(User, email: username) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end def get_by(sub: sub) do with %User{id: id, email: email} = user &lt;- Repo.get_by(User, id: sub) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end @impl Boruta.Oauth.ResourceOwners def check_password(resource_owner, password) do User.check_password(user, password) end @impl Boruta.Oauth.ResourceOwners def authorized_scopes(%ResourceOwner{}), do: [] endConfigurationBoruta provides several configuration options, to customize them you can add configurations in config.exs as followingconfig :boruta, Boruta.Oauth, repo: MyApp.Repo, cache_backend: Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: MyApp.ResourceOwners, scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24 ], token_generator: Boruta.TokenGeneratorIntegrationThis implementation follows a pseudo hexagonal architecture to invert dependencies to Application layer. In order to expose endpoints of an OAuth server with Boruta, you need implement the behaviour Boruta.Oauth.Application with all needed callbacks for token/2, authorize/2 and introspect/2 calls from Boruta.Oauth.This library has specific interfaces to interact with Plug.Conn requests.Here is an example of a token endpoint controller:defmodule MyApp.OauthController do @behaviour Boruta.Oauth.Application ... def token(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.token(__MODULE__) end @impl Boruta.Oauth.Application def token_success(conn, %TokenResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;token.json&quot;, response: response) end @impl Boruta.Oauth.Application def token_error(conn, %Error{status: status, error: error, error_description: error_description}) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end ... endFeedbackIt is a work in progress, all feedbacks / feature requests / improvements are welcome -&gt; me","ref":"Boruta.html","title":"Boruta","type":"module"},{"doc":"Utilities to access Boruta configuration ad set defaults.Configuration can be set as following in config.exs (this configuration is the default)config :boruta, Boruta.Oauth, repo: MyApp.Repo, cache_backend; Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: nil, scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24 ], token_generator: Boruta.TokenGenerator","ref":"Boruta.Config.html","title":"Boruta.Config","type":"module"},{"doc":"Boruta OAuth entrypoint, handles OAuth requests.Note : this module works in association with Boruta.Oauth.Application behaviour","ref":"Boruta.Oauth.html","title":"Boruta.Oauth","type":"module"},{"doc":"Process an authorize request and returns a token as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers authorize_success in case of success and authorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#authorize/3","title":"Boruta.Oauth.authorize/3","type":"function"},{"doc":"Process a introspect request as stated in RFC 7662 - OAuth 2.0 Token Introspection.Triggers introspect_success in case of success and introspect_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#introspect/2","title":"Boruta.Oauth.introspect/2","type":"function"},{"doc":"Process an authorize request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers preauthorize_success in case of success and preauthorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#preauthorize/3","title":"Boruta.Oauth.preauthorize/3","type":"function"},{"doc":"Process a revoke request as stated in RFC 7009 - OAuth 2.0 Token Revocation.Triggers revoke_success in case of success and revoke_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#revoke/2","title":"Boruta.Oauth.revoke/2","type":"function"},{"doc":"Process an token request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers token_success in case of success and token_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#token/2","title":"Boruta.Oauth.token/2","type":"function"},{"doc":"OAuth application behaviourImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.Application.html","title":"Boruta.Oauth.Application","type":"behaviour"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_error/2","title":"Boruta.Oauth.Application.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_success/2","title":"Boruta.Oauth.Application.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_error/2","title":"Boruta.Oauth.Application.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_success/2","title":"Boruta.Oauth.Application.introspect_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_error/2","title":"Boruta.Oauth.Application.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_success/2","title":"Boruta.Oauth.Application.preauthorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_error/2","title":"Boruta.Oauth.Application.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_success/1","title":"Boruta.Oauth.Application.revoke_success/1","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_error/2","title":"Boruta.Oauth.Application.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_success/2","title":"Boruta.Oauth.Application.token_success/2","type":"callback"},{"doc":"Migration task for Boruta.Creates clients, scopes and tokens tables.Examplesmix boruta.gen.migration","ref":"Mix.Tasks.Boruta.Gen.Migration.html","title":"Mix.Tasks.Boruta.Gen.Migration","type":"task"},{"doc":"Authorize response","ref":"Boruta.Oauth.AuthorizeResponse.html","title":"Boruta.Oauth.AuthorizeResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#from_token/1","title":"Boruta.Oauth.AuthorizeResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#t:t/0","title":"Boruta.Oauth.AuthorizeResponse.t/0","type":"type"},{"doc":"Introspect response","ref":"Boruta.Oauth.IntrospectResponse.html","title":"Boruta.Oauth.IntrospectResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_error/1","title":"Boruta.Oauth.IntrospectResponse.from_error/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_token/1","title":"Boruta.Oauth.IntrospectResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#t:t/0","title":"Boruta.Oauth.IntrospectResponse.t/0","type":"type"},{"doc":"Token response","ref":"Boruta.Oauth.TokenResponse.html","title":"Boruta.Oauth.TokenResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#from_token/1","title":"Boruta.Oauth.TokenResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#t:t/0","title":"Boruta.Oauth.TokenResponse.t/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.Authorization.html","title":"Boruta.Oauth.Authorization","type":"protocol"},{"doc":"Checks if request is valid for token creation for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#preauthorize/1","title":"Boruta.Oauth.Authorization.preauthorize/1","type":"function"},{"doc":"Creates and returns a token for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#token/1","title":"Boruta.Oauth.Authorization.token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.html#t:t/0","title":"Boruta.Oauth.Authorization.t/0","type":"type"},{"doc":"Access token authorization","ref":"Boruta.Oauth.Authorization.AccessToken.html","title":"Boruta.Oauth.Authorization.AccessToken","type":"module"},{"doc":"Authorize the access token corresponding to the given params.Examplesiex&gt; authorize(%{value: &quot;value&quot;}) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.AccessToken.html#authorize/1","title":"Boruta.Oauth.Authorization.AccessToken.authorize/1","type":"function"},{"doc":"Client authorization","ref":"Boruta.Oauth.Authorization.Client.html","title":"Boruta.Oauth.Authorization.Client","type":"module"},{"doc":"Authorize the client corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;, secret: &quot;secret&quot;) {:ok, %Boruta.Oauth.Client{...}}","ref":"Boruta.Oauth.Authorization.Client.html#authorize/1","title":"Boruta.Oauth.Authorization.Client.authorize/1","type":"function"},{"doc":"Code authorization","ref":"Boruta.Oauth.Authorization.Code.html","title":"Boruta.Oauth.Authorization.Code","type":"module"},{"doc":"Authorize the code corresponding to the given params.Examplesiex&gt; authorize(value: &quot;value&quot;, redirect_uri: &quot;redirect_uri&quot;) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.Code.html#authorize/1","title":"Boruta.Oauth.Authorization.Code.authorize/1","type":"function"},{"doc":"Resource owner authorization","ref":"Boruta.Oauth.Authorization.ResourceOwner.html","title":"Boruta.Oauth.Authorization.ResourceOwner","type":"module"},{"doc":"Authorize the resource owner corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;) {:ok, %User{...}}","ref":"Boruta.Oauth.Authorization.ResourceOwner.html#authorize/1","title":"Boruta.Oauth.Authorization.ResourceOwner.authorize/1","type":"function"},{"doc":"Scope authorization","ref":"Boruta.Oauth.Authorization.Scope.html","title":"Boruta.Oauth.Authorization.Scope","type":"module"},{"doc":"Authorize the given scope according to the given client.Examplesiex&gt; authorize(%{scope: &quot;scope&quot;, client: %Client{...}}) {:ok, &quot;scope&quot;}","ref":"Boruta.Oauth.Authorization.Scope.html#authorize/1","title":"Boruta.Oauth.Authorization.Scope.authorize/1","type":"function"},{"doc":"OAuth Introspect","ref":"Boruta.Oauth.Introspect.html","title":"Boruta.Oauth.Introspect","type":"module"},{"doc":"Returns corresponding token for the given Boruta.Oauth.IntrospectRequestNote : Invalid tokens returns an error {:error, %Error{error: :invalid_access_token, ...}}. That must be rescued to return %{&quot;active&quot; =&gt; false} in application implementation.Examplesiex&gt; token(%IntrospectRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) {:ok, %Token{...}}","ref":"Boruta.Oauth.Introspect.html#token/1","title":"Boruta.Oauth.Introspect.token/1","type":"function"},{"doc":"OAuth Revoke","ref":"Boruta.Oauth.Revoke.html","title":"Boruta.Oauth.Revoke","type":"module"},{"doc":"Revokes token according to the given Boruta.Oauth.RevokeRequestExamplesiex&gt; token(%RevokeRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) :ok","ref":"Boruta.Oauth.Revoke.html#token/1","title":"Boruta.Oauth.Revoke.token/1","type":"function"},{"doc":"Access token context","ref":"Boruta.Oauth.AccessTokens.html","title":"Boruta.Oauth.AccessTokens","type":"behaviour"},{"doc":"Persists a token with the given params.","ref":"Boruta.Oauth.AccessTokens.html#c:create/2","title":"Boruta.Oauth.AccessTokens.create/2","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token either by value or refresh_token.","ref":"Boruta.Oauth.AccessTokens.html#c:get_by/1","title":"Boruta.Oauth.AccessTokens.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token.","ref":"Boruta.Oauth.AccessTokens.html#c:revoke/1","title":"Boruta.Oauth.AccessTokens.revoke/1","type":"callback"},{"doc":"Client context","ref":"Boruta.Oauth.Clients.html","title":"Boruta.Oauth.Clients","type":"behaviour"},{"doc":"Returns client authorized scopes. The scopes will be granted for every requests to the given client.","ref":"Boruta.Oauth.Clients.html#c:authorized_scopes/1","title":"Boruta.Oauth.Clients.authorized_scopes/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Client by either id and secret ou by id and redirect_uri.","ref":"Boruta.Oauth.Clients.html#c:get_by/1","title":"Boruta.Oauth.Clients.get_by/1","type":"callback"},{"doc":"Code context","ref":"Boruta.Oauth.Codes.html","title":"Boruta.Oauth.Codes","type":"behaviour"},{"doc":"Persists a token according to given params.","ref":"Boruta.Oauth.Codes.html#c:create/1","title":"Boruta.Oauth.Codes.create/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token by value and redirect_uri.","ref":"Boruta.Oauth.Codes.html#c:get_by/1","title":"Boruta.Oauth.Codes.get_by/1","type":"callback"},{"doc":"Resource owner context","ref":"Boruta.Oauth.ResourceOwners.html","title":"Boruta.Oauth.ResourceOwners","type":"behaviour"},{"doc":"Returns a list of authorized scopes for a given resource owner. These scopes will be granted is requested for the user.","ref":"Boruta.Oauth.ResourceOwners.html#c:authorized_scopes/1","title":"Boruta.Oauth.ResourceOwners.authorized_scopes/1","type":"callback"},{"doc":"Determines if given password is correct.","ref":"Boruta.Oauth.ResourceOwners.html#c:check_password/2","title":"Boruta.Oauth.ResourceOwners.check_password/2","type":"callback"},{"doc":"Returns a resource owner by (username, password) or (id). Returns nil for non matching results.","ref":"Boruta.Oauth.ResourceOwners.html#c:get_by/1","title":"Boruta.Oauth.ResourceOwners.get_by/1","type":"callback"},{"doc":"Scope context","ref":"Boruta.Oauth.Scopes.html","title":"Boruta.Oauth.Scopes","type":"behaviour"},{"doc":"","ref":"Boruta.Oauth.Scopes.html#c:public/0","title":"Boruta.Oauth.Scopes.public/0","type":"callback"},{"doc":"OAuth client schema","ref":"Boruta.Oauth.Client.html","title":"Boruta.Oauth.Client","type":"module"},{"doc":"","ref":"Boruta.Oauth.Client.html#t:t/0","title":"Boruta.Oauth.Client.t/0","type":"type"},{"doc":"Oauth resource owner","ref":"Boruta.Oauth.ResourceOwner.html","title":"Boruta.Oauth.ResourceOwner","type":"module"},{"doc":"","ref":"Boruta.Oauth.ResourceOwner.html#t:t/0","title":"Boruta.Oauth.ResourceOwner.t/0","type":"type"},{"doc":"Schema defining an independent OAuth scope","ref":"Boruta.Oauth.Scope.html","title":"Boruta.Oauth.Scope","type":"module"},{"doc":"Splits an OAuth scope string into individual scopes as stringExamplesiex&gt; scope(&quot;a:scope another:scope&quot;) [&quot;a:scope&quot;, &quot;another:scope&quot;]","ref":"Boruta.Oauth.Scope.html#split/1","title":"Boruta.Oauth.Scope.split/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:t/0","title":"Boruta.Oauth.Scope.t/0","type":"type"},{"doc":"Token schema. Representing both access tokens and codes.","ref":"Boruta.Oauth.Token.html","title":"Boruta.Oauth.Token","type":"module"},{"doc":"Determines if a token is expiredExamplesiex&gt; expired?(%Boruta.Oauth.Token{expires_at: 1638316800}) # 1st january 2021 :ok iex&gt; expired?(%Boruta.Oauth.Token{expires_at: 0}) # 1st january 1970 {:error, &quot;Token expired.&quot;}","ref":"Boruta.Oauth.Token.html#expired?/1","title":"Boruta.Oauth.Token.expired?/1","type":"function"},{"doc":"Returns an hexadecimal SHA512 hash of given stringExamplesiex&gt; hash(&quot;foo&quot;) &quot;F7FBBA6E0636F890E56FBBF3283E524C6FA3204AE298382D624741D0DC6638326E282C41BE5E4254D8820772C5518A2C5A8C0C7F7EDA19594A7EB539453E1ED7&quot;","ref":"Boruta.Oauth.Token.html#hash/1","title":"Boruta.Oauth.Token.hash/1","type":"function"},{"doc":"Determines if a token is revoked.Examplesiex&gt; revoked?(%Boruta.Oauth.Token{revoked_at: nil}) :ok iex&gt; revoked?(%Boruta.Oauth.Token{}) {:error, &quot;Token revoked.&quot;}","ref":"Boruta.Oauth.Token.html#revoked?/1","title":"Boruta.Oauth.Token.revoked?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Token.html#t:t/0","title":"Boruta.Oauth.Token.t/0","type":"type"},{"doc":"Authorization code request","ref":"Boruta.Oauth.AuthorizationCodeRequest.html","title":"Boruta.Oauth.AuthorizationCodeRequest","type":"module"},{"doc":"Type representing an authorization code request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.AuthorizationCodeRequest.html#t:t/0","title":"Boruta.Oauth.AuthorizationCodeRequest.t/0","type":"type"},{"doc":"Client credentials request","ref":"Boruta.Oauth.ClientCredentialsRequest.html","title":"Boruta.Oauth.ClientCredentialsRequest","type":"module"},{"doc":"Type representing a client credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.ClientCredentialsRequest.html#t:t/0","title":"Boruta.Oauth.ClientCredentialsRequest.t/0","type":"type"},{"doc":"Code request","ref":"Boruta.Oauth.CodeRequest.html","title":"Boruta.Oauth.CodeRequest","type":"module"},{"doc":"Type representing a code request as stated in OAuth 2.0 RFC.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.CodeRequest.html#t:t/0","title":"Boruta.Oauth.CodeRequest.t/0","type":"type"},{"doc":"Introspect request","ref":"Boruta.Oauth.IntrospectRequest.html","title":"Boruta.Oauth.IntrospectRequest","type":"module"},{"doc":"Type representing an introspect request as stated in Introspect RFC.","ref":"Boruta.Oauth.IntrospectRequest.html#t:t/0","title":"Boruta.Oauth.IntrospectRequest.t/0","type":"type"},{"doc":"Resource owner password credentials request","ref":"Boruta.Oauth.PasswordRequest.html","title":"Boruta.Oauth.PasswordRequest","type":"module"},{"doc":"Type representing a resource owner password credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.PasswordRequest.html#t:t/0","title":"Boruta.Oauth.PasswordRequest.t/0","type":"type"},{"doc":"Refresh token request","ref":"Boruta.Oauth.RefreshTokenRequest.html","title":"Boruta.Oauth.RefreshTokenRequest","type":"module"},{"doc":"Type representing a refresh token request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.RefreshTokenRequest.html#t:t/0","title":"Boruta.Oauth.RefreshTokenRequest.t/0","type":"type"},{"doc":"Build an oauth request struct from given input.Note : Input must have the shape or be a %Plug.Conn{} request.","ref":"Boruta.Oauth.Request.html","title":"Boruta.Oauth.Request","type":"module"},{"doc":"Create request struct from an OAuth authorize request.Note : resource owner must be provided as current_user assigns.Examplesiex&gt;authorize_request( %{ query_params: %{ &quot;response_type&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;redirect_uri&quot; =&gt; &quot;redirect_uri&quot; }, }, %User{...} ) {:ok, %TokenRequest{...}}","ref":"Boruta.Oauth.Request.html#authorize_request/2","title":"Boruta.Oauth.Request.authorize_request/2","type":"function"},{"doc":"Create request struct from an OAuth introspect request.Examplesiex&gt;introspect_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %IntrospectRequest{...}}","ref":"Boruta.Oauth.Request.html#introspect_request/1","title":"Boruta.Oauth.Request.introspect_request/1","type":"function"},{"doc":"Create request struct from an OAuth revoke request.Examplesiex&gt;revoke_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %RevokeRequest{...}}","ref":"Boruta.Oauth.Request.html#revoke_request/1","title":"Boruta.Oauth.Request.revoke_request/1","type":"function"},{"doc":"Create request struct from an OAuth token request.Examplesiex&gt;token_request(%{ body_params: %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } }) {:ok, %ClientCredentialsRequest{...}}","ref":"Boruta.Oauth.Request.html#token_request/1","title":"Boruta.Oauth.Request.token_request/1","type":"function"},{"doc":"Revoke request","ref":"Boruta.Oauth.RevokeRequest.html","title":"Boruta.Oauth.RevokeRequest","type":"module"},{"doc":"Type representing an revoke request as stated in OAuth 2.0 Token revocation RFC.","ref":"Boruta.Oauth.RevokeRequest.html#t:t/0","title":"Boruta.Oauth.RevokeRequest.t/0","type":"type"},{"doc":"Implicit request","ref":"Boruta.Oauth.TokenRequest.html","title":"Boruta.Oauth.TokenRequest","type":"module"},{"doc":"Type representing an implicit request as stated in OAuth 2.0 RFC.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.TokenRequest.html#t:t/0","title":"Boruta.Oauth.TokenRequest.t/0","type":"type"},{"doc":"Administration of Boruta resources.","ref":"Boruta.Ecto.Admin.html","title":"Boruta.Ecto.Admin","type":"module"},{"doc":"See Boruta.Ecto.Admin.Clients.create_client/1.","ref":"Boruta.Ecto.Admin.html#create_client/1","title":"Boruta.Ecto.Admin.create_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.create_scope/1.","ref":"Boruta.Ecto.Admin.html#create_scope/1","title":"Boruta.Ecto.Admin.create_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.delete_client/1.","ref":"Boruta.Ecto.Admin.html#delete_client/1","title":"Boruta.Ecto.Admin.delete_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.delete_scope/1.","ref":"Boruta.Ecto.Admin.html#delete_scope/1","title":"Boruta.Ecto.Admin.delete_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.get_client!/1.","ref":"Boruta.Ecto.Admin.html#get_client!/1","title":"Boruta.Ecto.Admin.get_client!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scope!/1.","ref":"Boruta.Ecto.Admin.html#get_scope!/1","title":"Boruta.Ecto.Admin.get_scope!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1.","ref":"Boruta.Ecto.Admin.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.get_scopes_by_ids/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.list_clients/0.","ref":"Boruta.Ecto.Admin.html#list_clients/0","title":"Boruta.Ecto.Admin.list_clients/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.list_scopes/0.","ref":"Boruta.Ecto.Admin.html#list_scopes/0","title":"Boruta.Ecto.Admin.list_scopes/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.update_client/2.","ref":"Boruta.Ecto.Admin.html#update_client/2","title":"Boruta.Ecto.Admin.update_client/2","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.update_scope/2.","ref":"Boruta.Ecto.Admin.html#update_scope/2","title":"Boruta.Ecto.Admin.update_scope/2","type":"function"},{"doc":"Boruta.Ecto.Client resource administration.","ref":"Boruta.Ecto.Admin.Clients.html","title":"Boruta.Ecto.Admin.Clients","type":"module"},{"doc":"Creates a client.Examplesiex&gt; create_client(%{field: value}) {:ok, %Client{}} iex&gt; create_client(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#create_client/1","title":"Boruta.Ecto.Admin.Clients.create_client/1","type":"function"},{"doc":"Deletes a Client.Examplesiex&gt; delete_client(client) {:ok, %Client{}} iex&gt; delete_client(client) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#delete_client/1","title":"Boruta.Ecto.Admin.Clients.delete_client/1","type":"function"},{"doc":"Gets a single client.Raises Ecto.NoResultsError if the Client does not exist.Examplesiex&gt; get_client!(123) %Client{} iex&gt; get_client!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Clients.html#get_client!/1","title":"Boruta.Ecto.Admin.Clients.get_client!/1","type":"function"},{"doc":"Returns the list of clients.Examplesiex&gt; list_clients() [%Client{}, ...]","ref":"Boruta.Ecto.Admin.Clients.html#list_clients/0","title":"Boruta.Ecto.Admin.Clients.list_clients/0","type":"function"},{"doc":"Updates a client.Examplesiex&gt; update_client(client, %{field: new_value}) {:ok, %Client{}} iex&gt; update_client(client, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#update_client/2","title":"Boruta.Ecto.Admin.Clients.update_client/2","type":"function"},{"doc":"Boruta.Ecto.Scope resource administration.","ref":"Boruta.Ecto.Admin.Scopes.html","title":"Boruta.Ecto.Admin.Scopes","type":"module"},{"doc":"Creates a scope.Examplesiex&gt; create_scope(%{field: value}) {:ok, %Scope{}} iex&gt; create_scope(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#create_scope/1","title":"Boruta.Ecto.Admin.Scopes.create_scope/1","type":"function"},{"doc":"Deletes a Scope.Examplesiex&gt; delete_scope(scope) {:ok, %Scope{}} iex&gt; delete_scope(scope) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#delete_scope/1","title":"Boruta.Ecto.Admin.Scopes.delete_scope/1","type":"function"},{"doc":"Gets a single scope.Raises Ecto.NoResultsError if the Scope does not exist.Examplesiex&gt; get_scope!(123) %Scope{} iex&gt; get_scope!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Scopes.html#get_scope!/1","title":"Boruta.Ecto.Admin.Scopes.get_scope!/1","type":"function"},{"doc":"","ref":"Boruta.Ecto.Admin.Scopes.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1","type":"function"},{"doc":"Returns the list of scopes.Examplesiex&gt; list_scopes() [%Scope{}, ...]","ref":"Boruta.Ecto.Admin.Scopes.html#list_scopes/0","title":"Boruta.Ecto.Admin.Scopes.list_scopes/0","type":"function"},{"doc":"Updates a scope.Examplesiex&gt; update_scope(scope, %{field: new_value}) {:ok, %Scope{}} iex&gt; update_scope(scope, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#update_scope/2","title":"Boruta.Ecto.Admin.Scopes.update_scope/2","type":"function"},{"doc":"HTTP BasicAuth utilitiesProvide utilities to decode Basic authorization header as stated in RFC 7617 - The 'Basic' HTTP Authentication Scheme","ref":"Boruta.BasicAuth.html","title":"Boruta.BasicAuth","type":"module"},{"doc":"Decode given authorization header and returns an array containing username and password.Examplesiex&gt; Boruta.BasicAuth.decode(&quot;Basic dXNlcm5hbWU6cGFzc3dvcmQ=&quot;) {:ok, [&quot;username&quot;, &quot;password&quot;]} iex&gt; Boruta.BasicAuth.decode(&quot;bad_authorization_header&quot;) {:error, &quot;`bad_authorization_header` is not a valid Basic authorization header.&quot;}","ref":"Boruta.BasicAuth.html#decode/1","title":"Boruta.BasicAuth.decode/1","type":"function"},{"doc":"This is the cache for the primary storage.","ref":"Boruta.Cache.Primary.html","title":"Boruta.Cache.Primary","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"Boruta.Cache.Primary.html#generations/0","title":"Boruta.Cache.Primary.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"Boruta.Cache.Primary.html#new_generation/1","title":"Boruta.Cache.Primary.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"Boruta.Cache.Primary.html#newer_generation/0","title":"Boruta.Cache.Primary.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"Boruta.Cache.Primary.html#reset_generation_timer/0","title":"Boruta.Cache.Primary.reset_generation_timer/0","type":"function"},{"doc":"Behaviour to implement utilities to generate token value. This must be implemented in the module configured as token_generator set in config.exs","ref":"Boruta.Oauth.TokenGenerator.html","title":"Boruta.Oauth.TokenGenerator","type":"behaviour"},{"doc":"Generates a token value from token entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:generate/2","title":"Boruta.Oauth.TokenGenerator.generate/2","type":"callback"},{"doc":"Generates a secret from client entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:secret/1","title":"Boruta.Oauth.TokenGenerator.secret/1","type":"callback"},{"doc":"Utility to validate the request according to the given parameters.","ref":"Boruta.Oauth.Validator.html","title":"Boruta.Oauth.Validator","type":"module"},{"doc":"Validates given OAuth parameters.Examplesiex&gt; validate(%{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }) {:ok, %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }} iex&gt; validate(%{}) {:error, &quot;Request is not a valid OAuth request. Need a grant_type or a response_type param.&quot;}","ref":"Boruta.Oauth.Validator.html#validate/2","title":"Boruta.Oauth.Validator.validate/2","type":"function"},{"doc":"Boruta OAuth errorsIntended to follow OAuth 2.0 errors. Additionnal errors are provided as purpose.","ref":"Boruta.Oauth.Error.html","title":"Boruta.Oauth.Error","type":"module"},{"doc":"","ref":"Boruta.Oauth.Error.html#with_format/2","title":"Boruta.Oauth.Error.with_format/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Error.html#t:t/0","title":"Boruta.Oauth.Error.t/0","type":"type"}]